package de.akquinet.angularjs.rest;

import javax.ejb.Stateless;
import javax.inject.Inject;
import javax.ws.rs.FormParam;
import javax.ws.rs.POST;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;
import javax.ws.rs.core.MediaType;

import de.akquinet.angularjs.User;
import de.akquinet.angularjs.dao.UserDao;

@Stateless
@Path("authentication")
public class AuthenticationService {

	@Inject
	private UserDao userDao;

	@POST
	@Produces({ MediaType.APPLICATION_JSON, MediaType.TEXT_XML })
	public User authenticate(@FormParam("username") String username,
			@FormParam("password") String password) {
		final User user = userDao.findByUsername(username);

		if (user == null || !user.verifyPassword(password)) {
			//TODO throw UnauthorizedException
			throw new RuntimeException();
		}

		return user;
	}
}
